//RepartirTabulations_D_501d.js
// 29.05.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Rpartir les positions des tabulations

/*
Credits: une extension du script "spaltenbreite_nach_lngster_spalte.jsx" 
par Gerald Singelmann (-> http://www.cuppascript.com 	)
*/

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// deux balises utilises pour l'affichage unique des deux dialogues
dlog_N_shown = false;
dlog_Y_shown = false;

// appeler la fonction qui lit les prfrences mmorises
var allPrefs_N = getPrefs_N(); // pour les paragraphes sans tabulations
if (allPrefs_N != "") {
	var prefVal_N = allPrefs_N.split("\n");
	// Option 1: montrer le dialogue (= 1) ou ne pas le montrer (= 0)
	showDlog_N = prefVal_N[0];
	if (showDlog_N == "0") {
		ck00 = 1;
		ck01 = 0;
	}
	else {
		ck00 = 0;
		ck01 = 1;
	}
	// Option 2: l'espace entre les colonnes (quand il n'y a pas de tabulations)
	horGap = prefVal_N[1]*1;
	// Option 4: le facteur de prcision des nouvelles valeurs de position
	// 0 = ne pas arrondir;  0.1 = diximes de millimtre;  0.5 = demi-millimtre;  1 = millimtres entiers
	// utiliser un point comme caractre de sparation (pas de comma)
	rndFact_N = prefVal_N[2]*1;
}
else {
	// sinon utiliser les valeurs par dfaut 
	// quand le fichier des prfrences n'existe pas
	showDlog_N = "1";
	ck00       = 0;
	ck01       = 1;
	horGap     = 4;
	rndFact_N  = 0.1;
}

// appeler la fonction qui lit les prfrences mmorises
var allPrefs_Y = getPrefs_Y(); // pour des paragraphes avec tabulations
if (allPrefs_Y != "") {
	var prefVal_Y = allPrefs_Y.split("\n");
	// Option 1: montrer le dialogue (= 1) ou ne pas le montrer (= 0)
	showDlog_Y = prefVal_Y[0];
	if (showDlog_Y == "0") {
		ck02 = 1;
		ck03 = 0;
	}
	else {
		ck02 = 0;
		ck03 = 1;
	}
	// Option 3: la premire position  modifier
	firstStop = prefVal_Y[1]*1;
	// Option 4: le facteur de prcision des nouvelles valeurs de position
	// 0 = ne pas arrondir;  0.1 = dizimes de millimtre;  0.5 = demi millimtre;  1 = millimtres entiers
	// utiliser un point comme caractre de sparation (pas de comma)
	rndFact_Y = prefVal_Y[2]*1;
}
else {
	// sinon utiliser les valeurs par dfaut 
	// quand le fichier des prfrences n'existe pas
	showDlog_Y = "1";
	ck02       = 0;
	ck03       = 1;
	firstStop  = 1;
	rndFact_Y  = 0.1;
}

// appeler trois autres fonctions
firstChecks();
reStore();
infUser();


///////////////////// les fonctions  /////////////////////////////////////////////

// la fonction qui renvoie les valeurs mmorises  ///////////////////////////////
function getPrefs_N() {
	var allPrefs_N = "";
	// lire le fichier qui contient les valeurs mmorises
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Tabulations_non_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Tabulations_non_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs_N = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs_N;
}

function getPrefs_Y() {
	var allPrefs_Y = "";
	// lire le fichier qui contient les valeurs mmorises
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/Tabulations_oui_501.txt");
	}
	else {
		var f = new File("~/Library/Preferences/Tabulations_oui_501.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs_Y = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs_Y;
}

// les premiers tests ////////////////////////////////////////////////////////////
function firstChecks() {
	// vrifier s'il y a un document ouvert
	if (app.documents.length == 0) {
		alert ("Il n'y a pas de document ouvert.", "Attention");
		exit();
	}
	
	// le document au premier plan
	curDoc = app.documents[0];
	
	// vrifier les valeurs par dfaut
	try {
		if (isNaN(horGap)) {
			horGap = 4;
		}
	}
	catch (e) {
		horGap = 4;
	}
	if (horGap < 1) {
		horGap = 1;
	}
	try {
		if (isNaN(firstStop)) {
			firstStop = 1;
		}
	}
	catch (e) {
		firstStop = 1;
	}
	if (firstStop < 0) {
		firstStop = 1;
	}
	firstStop = Math.floor(firstStop);
	if (firstStop == 0) {
		firstStop = 1;
	}
	try {
		if (isNaN(rndFact_N)) {
			rndFact_N = 0.1;
		}
	}
	catch (e) {
		rndFact_N = 0.1;
	}
	if (rndFact_N != 0 && rndFact_N != 0.1 && rndFact_N != 0.5 && rndFact_N != 1) {
		rndFact_N = 0.1;
	}
	try {
		if (isNaN(rndFact_Y)) {
			rndFact_Y = 0.1;
		}
	}
	catch (e) {
		rndFact_Y = 0.1;
	}
	if (rndFact_Y != 0 && rndFact_Y != 0.1 && rndFact_Y != 0.5 && rndFact_Y != 1) {
		rndFact_Y = 0.1;
	}

	// mmoriser et vrifier la slection
	curSel = app.selection;
	if (curSel.length == 0) {
		alert ("Il n'y a pas de slection.", "Attention");
		exit();
	}
	if (curSel[0].hasOwnProperty("baseline") == true) {
		if (curSel[0].contents.indexOf("\t") == -1) {
			alert ("Le texte slectionn ne contient pas de tabulations.", "Stop");
			exit();
		}
		changeUnits();
		var isLocked = false;
		if (curSel[0].parent.textContainers[0].locked == true) {
			curSel[0].parent.textContainers[0].locked = false;
			isLocked = true;
		}
		checkParas(curSel[0]);
		if (isLocked) {
			curSel[0].parent.textContainers[0].locked = true;
		}
	}
	else {
		changeUnits();
		for (var s=0; s<curSel.length; s++) {
			var curType = curSel[s].constructor.name;
			var isLocked = false;
			if (curType == "TextFrame") {
				if (curSel[s].locked == true) {
					curSel[s].locked = false;
					isLocked = true;
				}
				checkParas(curSel[s]);
				if (isLocked) {
					curSel[s].locked = true;
				}
			}
			else if (curType == "Group") {
				if (curSel[s].locked == true) {
					curSel[s].locked = false;
					isLocked = true;
				}
				var allItems = curSel[s].allPageItems;
				for (var n=0; n<allItems.length; n++) {
					var curType = allItems[n].constructor.name;
					if (curType == "TextFrame") {
						checkParas(allItems[n]);
					}
				}
				if (isLocked) {
					curSel[s].locked = true;
				}
			}
		}
	}
}

// vrifier les units et le point zro //////////////////////////////////////////
function changeUnits() {
	// mmoriser les units de mesure
	// si ce n'est pas 2053991795 (= millimtres), modifier  millimtres
	hM = curDoc.viewPreferences.horizontalMeasurementUnits;
	vM = curDoc.viewPreferences.verticalMeasurementUnits;
	
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	}
	// mettre le point zro  zro/zro
	zP = curDoc.zeroPoint; 
	if (zP != [0,0]) { 
		curDoc.zeroPoint = [0,0]; 
	}
}

// vrifier les paragraphes //////////////////////////////////////////////////////
function checkParas(sel) {
	// les paragraphes de la slection et leur nombre
	allParas = sel.paragraphs;
	nParas = allParas.length;
	
	// une boucle  travers les paragraphes
	startPara = -1;
	for (var p=0; p<nParas; p++) {
		if (allParas[p].contents.indexOf("\t") != -1) {
			startPara = p;
			break;
		}
	}
	if (startPara == -1) {
		return;
	}
	
	// vrifier s'il y a des tabulations
	if (allParas[startPara].tabStops.length != 0) {
		noStops = false;
	}
	else {
		noStops = true;
	}
	
	// mmoriser les valeurs des retraits
	if (noStops == false) {
		leftInd  = allParas[startPara].leftIndent;
		firstInd = allParas[startPara].firstLineIndent;
	}

	// restaurer les prfrences rechercher/remplacer
	app.findGrepPreferences = app.changeGrepPreferences = null;
	
	// la prfrence rechercher
	app.findGrepPreferences.findWhat = "\t|~y";
	
	allTabs = new Array();
	allLines = sel.lines;
	nLines   = allLines.length;
	// une boucle  travers des lignes
	for (var n=0; n<nLines; n++) {
		var curRes = allLines[n].findGrep();
		if (curRes.length != 0) {
			allTabs.push(curRes);
		}
	}
	
	// restaurer les prfrences rechercher/remplacer
	app.findGrepPreferences = app.changeGrepPreferences = null;
	
	// appeler la fonction pour calculer et modifier les positions
	changeTabPos();
}

// modifier (ou dfinir) les positions des tabulations ///////////////////////////
function changeTabPos() {
	// quand il n'y a pas de tabulations dfinies
	if (noStops) {
		// montrer le dialogue (quand la valeur de 'showDlog_N' est "1")
		if (showDlog_N == "1") {
			// mais uniquement lors de la premire fois de la sance actuelle
			if (dlog_N_shown == false) {
				var anArray  = askUser_No();
				horGap       = anArray[0];
				rndFact_N    = anArray[1];
				dlog_N_shown = true;
			}
		}
		// la position horizontale du premier paragraphe
		var startVal = allParas[startPara].insertionPoints[0].horizontalOffset;
		// arrondir selon la prfrences, afin que la position du bloc texte ne fausse pas le rsultat
		if (rndFact_N != 0) {
			startVal = Math.round(startVal/rndFact_N)*rndFact_N;
		}
		var nTabs = allTabs[0].length;
		var nPara = allParas.length;
		// dfinir la valeur de modification de la valeur d'arrt
		var stopMod = 0;
		// vrifier la prsence d'une tabulation  droite
		if (allParas[startPara].contents.indexOf("\u0008") != -1) {
			// si c'est la cas, modifier la valeur de modification
			stopMod = 1;
		}
		// relever la ligne la plus longue de chaque colonne
		for (var t=0; t<nTabs-stopMod; t++) {
			var x = -999;
			for (var n=0; n<nLines; n++) {
				var pTabs = allTabs[n];
				try {
					x = Math.max(x, pTabs[t].horizontalOffset);
				}
				catch (e) {
				}
			}
			// arrondir le rsultat
			if (rndFact_N != 0) {
				x = Math.round(x/rndFact_N)*rndFact_N;
			}
			// appliquer une tabulation  chaque paragraphe...
			for (var p=0; p<nParas; p++) {
				// ... quand ils contiennent des caractres de tabulation
				if (allParas[p].contents.indexOf("\t") != -1) {
					allParas[p].tabStops.add({alignment:TabStopAlignment.LEFT_ALIGN, position:x-startVal+horGap});
				}
			}
		}
	}
	// lorsqu'il y a des tabulations dfinies
	else {
		// montrer le dialogue (quand la valeur de 'showDlog_Y' est "1")
		if (showDlog_Y == "1") {
			// mais uniquement lors de la premire fois de la sance actuelle
			if (dlog_Y_shown == false) {
				var anArray  = askUser_Yes();
				firstStop    = anArray[0];
				rndFact_Y    = anArray[1];
				dlog_Y_shown = true;
			}
		}
		startCol = firstStop-1;
		var horOffsets = new Array();
		var nTabs = allTabs[0].length;
		var nPara = allParas.length;
		// vrifier s'il y a des retraits
		var withIndent = false;
		var mv = 0;
		if (leftInd > 0) {
			var startVal = Math.round((allParas[startPara].insertionPoints[0].horizontalOffset)*1000)/1000;
			var firstEnd = Math.round((allTabs[0][0].insertionPoints[-1].horizontalOffset)*1000)/1000;
			if (firstEnd+firstInd == startVal) {
				withIndent = true;
				if (allParas[startPara].tabStops[0].position == leftInd) {
					mv = 1;
				}
			}
		}
		// unifier les positions des tabulations
		var allStops = allParas[startPara].tabList;
		for (var p=0; p<allParas.length; p++) {
			if (allParas[p].tabStops.length != 0) {
				try {
					allParas[p].tabList = allStops;
				}
				catch (e) {
				}
			}
		}
		
		// vrifier si le premier paragraphe commence par un caractre tabulation
		// si ce n'est pas le cas, mettre la valeur de la premire colonne  modifier  2 (= colonne 3)
		//  moins que 'startCol' soit dfinie  une autre valeur que zro
		if (allParas[startPara].characters[0].contents == "\t") {
			if (startCol == 0) {
				startCol = 2;
			}
		}
		
		// les positions maximales et minimales des espaces entre les colonnes...
		if (withIndent == false) { // pas de retrait
			for (var t=startCol; t<nTabs; t++) {
				var x1 = -999;
				var x2 = 999;
				for (var n=0; n<allTabs.length; n++) {
					var pTabs = allTabs[n];
					try {
						x1 = Math.max(x1, pTabs[t].insertionPoints[0].horizontalOffset);
						x2 = Math.min(x2, pTabs[t].insertionPoints[-1].horizontalOffset);
					}
					catch (e) {
					}
				}
				// ... et les ajouter  la liste
				horOffsets.push([x1, x2]);
			}
		}
		else { // avec retrait
			for (var t=startCol; t<nTabs; t++) {
				var x1 = -999;
				var x2 = 999;
				for (var n=0; n<allTabs.length; n++) {
					if (allLines[n].contents.indexOf("\t") != -1) {
						var pTabs = allTabs[n];
						if (pTabs.length == nTabs) {
							try {
								x1 = Math.max(x1, pTabs[t+1].insertionPoints[0].horizontalOffset);
								x2 = Math.min(x2, pTabs[t+1].insertionPoints[-1].horizontalOffset);
							}
							catch (e) {
							}
						}
						else {
							try {
								x1 = Math.max(x1, pTabs[t].insertionPoints[0].horizontalOffset);
								x2 = Math.min(x2, pTabs[t].insertionPoints[-1].horizontalOffset);
							}
							catch (e) {
							}
						}
					}
				}
				// ... et les ajouter  la liste
				if (x1 != -999) {
					horOffsets.push([x1, x2]);
				}
			}
		}
		// calculer les distances minimales et les convertir en liste
		var oldSpaces = new Array();
		for (var n=0; n<horOffsets.length; n++) {
			oldSpaces.push(horOffsets[n][1]-horOffsets[n][0]);
		}
		// additionner les espaces...
		var allSpaces = 0;
		for (var n=0; n<oldSpaces.length; n++) {
			allSpaces += oldSpaces[n];
		}
		if (withIndent == false) { // pas de retrait
			// ... et calculer la moyenne
			var newSpace = allSpaces/(nTabs-startCol);
			// lister les diffrences
			var dif = 0;
			var difPosArr = new Array();
			for (var n=0; n<(nTabs-1)-startCol; n++) {
				var curDif = (newSpace-oldSpaces[n]);
				difPosArr.push(curDif+dif);
				dif += curDif;
			}
			// calculer les nouvelles positions
			var newPos = new Array();
			for (var t=0; t<difPosArr.length; t++) {
				try {
					x = (allParas[startPara].tabStops[t+startCol].position)+difPosArr[t];
					if (rndFact_Y != 0) {
						x = Math.round(x/rndFact_Y)*rndFact_Y;
					}
					newPos.push(x);
				}
				catch (e) {
					alert ("Cela n'a pas march.", "Desol");
					reStore();
					exit();
				}
			}
			// mmoriser la liste des tabulations
			var allStops = allParas[startPara].tabList;
			// appliquer la nouvelle position aux tabulations
			for (var t=0; t<newPos.length; t++) {
				allStops[t+startCol].position = newPos[t];
			}
			// appliquer aux paragraphes la dfinition modifie
			for (var n=0; n<nPara; n++) {
				try {
					if (allParas[n].tabStops.length != 0) {
						allParas[n].tabList = allStops;
					}
				}
				catch (e) {
				}
			}
		}
		else { // avec retrait
			// ... calculer la moyenne
			var newSpace = allSpaces/(nTabs-startCol-1);
			// lister les diffrences
			var dif = 0;
			var difPosArr = new Array();
			for (var n=0; n<(nTabs-1)-startCol; n++) {
				var curDif = (newSpace-oldSpaces[n]);
				difPosArr.push(curDif+dif);
				dif += curDif;
			}
			// calculer les nouvelles positions
			var newPos = new Array();
			for (var t=0; t<difPosArr.length; t++) {
				try {
					x = (allParas[startPara].tabStops[t+startCol+mv].position)+difPosArr[t];
					if (rndFact_Y != 0) {
						x = Math.round(x/rndFact_Y)*rndFact_Y;
					}
					newPos.push(x);
				}
				catch (e) {
					alert ("Cela n'a pas march.", "Desol");
					reStore();
					exit();
				}
			}
			// mmoriser la liste des tabulations
			var allStops = allParas[startPara].tabList;
			// appliquer la nouvelle position aux tabulations
			for (var t=0; t<newPos.length; t++) {
				allStops[t+startCol].position = newPos[t];
			}
			// appliquer aux paragraphes la dfinition modifie
			for (var n=0; n<nPara; n++) {
				try {
					if (allParas[n].tabStops.length != 0) {
						allParas[n].tabList = allStops;
					}
				}
				catch (e) {
				}
			}
		}
	}
}

// prparer le dialogue et l'afficher ////////////////////////////////////////////
function askUser_No() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 184;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"Pas de tabulations dfinies"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"L'espace entre les colonnes:", minWidth:labelWidth});
						var gapField = realEditboxes.add({editValue:horGap, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"mm", minWidth:12});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Arrondir les positions:", minWidth:labelWidth});
						var rndField = realEditboxes.add({editValue:rndFact_N, minWidth:fieldWidth});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:70});
				with(showButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"ne plus afficher le dialogue", checkedState:ck00});
					radiobuttonControls.add({staticLabel:"afficher le dialogue", checkedState:ck01});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		// relever la saisie
		showDlog_N = showButtons.selectedButton;
		horGap     = gapField.editValue;
		rndFact_N  = rndField.editValue;
		// supprimer le dialogue
		aDialog.destroy();
		// vrifier la saisie
		if (rndFact_N != 0 && rndFact_N != 0.1 && rndFact_N != 0.5 && rndFact_N != 1) {
			rndFact_N = 0.1;
		}
		// la nouvelle liste des prfrences
		var prefsList = new Array (showDlog_N, horGap, rndFact_N);
		// la convertir en chane de texte
		var prefString = prefsList.join("\n");
		// l'envoyer  la fonction qui crit le rsultat dans un fichier
		writeResult(prefString, "/Tabulations_non_501.txt");
		// renvoyer le rsultat  l'appel de la fonction
		return [horGap, rndFact_N];
	}
	else{
		// lors d'un clic sur "Annuler": supprimer le dialogue...
		aDialog.destroy();
		// ... appeler la fonction pour restaurer les rglages...
		reStore();
		// ... et arrter l'excution
		exit();
	}
}

function askUser_Yes() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 184;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"Il y a des tabulations dfinies"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Premire position  modifier:", minWidth:labelWidth});
						var firstField = integerEditboxes.add({editValue:firstStop, minimumValue:1, maximumValue:10, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"      ", minWidth:12});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Arrondir les positions:", minWidth:labelWidth});
						var rndField = realEditboxes.add({editValue:rndFact_Y, minWidth:fieldWidth});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:" ", minWidth:70});
				with(showButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"ne plus afficher le dialogue", checkedState:ck02});
					radiobuttonControls.add({staticLabel:"afficher le dialogue", checkedState:ck03});
				}
			}
		}
	}
	if (aDialog.show() == true) {
		// relever la saisie
		showDlog_Y = showButtons.selectedButton;
		firstStop  = firstField.editValue;
		rndFact_Y  = rndField.editValue;
		// supprimer le dialogue
		aDialog.destroy();
		// vrifier la saisie
		if (rndFact_Y != 0 && rndFact_Y != 0.1 && rndFact_Y != 0.5 && rndFact_Y != 1) {
			rndFact_Y = 0.1;
		}
		// la nouvelle liste des prfrences
		var prefsList = new Array (showDlog_Y, firstStop, rndFact_Y);
		// la convertir en chane de texte
		var prefString = prefsList.join("\n");
		// l'envoyer  la fonction qui crit le rsultat dans un fichier
		writeResult(prefString, "/Tabulations_oui_501.txt");
		// renvoyer le rsultat  l'appel de la fonction
		return [firstStop, rndFact_Y];
	}
	else{
		// lors d'un clic sur "Annuler": supprimer le dialogue...
		aDialog.destroy();
		// ... appeler la fonction pour restaurer les rglages...
		reStore();
		// ... et arrter l'excution
		exit();
	}
}

// crire le rsultat dans un fichier ////////////////////////////////////////////
function writeResult(curPrefs, fiName) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + fiName);
	}
	else {
		var f = File("~/Library/Preferences" + fiName);
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// rtablir les rglages des prfrences /////////////////////////////////////////
function reStore() {
	// restaurer les units de mesure (si ncessaire)
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	// restaurer le point zro (si ncessaire)
	if (zP != [0,0]) { 
		curDoc.zeroPoint = zP; 
	}
}

// annoncer la fin de l'action ///////////////////////////////////////////////////
function infUser() {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Termin.");
	dlog.show();
	// une petite pause
	$.sleep(555);
	// fermer la fentre
	dlog.close();
}